
#include "stdafx.h"
#include "serial.h"
#include "lcd.h"
#include <stdio.h>


unsigned char lcdbuffer[480][1000];

void writebyte (unsigned char wert)
{
	if (wert==Escape)
		SendByte(Escape);
	SendByte(wert);
}

void writecom (unsigned char wert)
{
	SendByte(Escape);
	if (wert==Escape)
		SendByte(Escape);
	SendByte(wert);
}

void setpwm (unsigned char wert)
{
	unsigned char temp[5],i=0;
	temp[i++]=Escape;
	temp[i++]=2;
	if (wert==Escape)
		temp[i++]=Escape;
	temp[i++]=wert;
	SendString(temp, i);
}

void setscroll (unsigned char wert)
{
	unsigned char temp[5],i=0;
	temp[i++]=Escape;
	temp[i++]=3;
	if (wert==Escape)
		temp[i++]=Escape;
	temp[i++]=wert;
	SendString(temp, i);
}

void setcursor (unsigned int x, unsigned int y)
{
	unsigned char temp[10],i=0;
	temp[i++]=Escape;
	temp[i++]=1;
	if (((char)(y%240))==Escape)
		temp[i++]=Escape;
	temp[i++]=((char)(y%240));
	if (((char)((y/240)*128+(x/8)))==Escape)
		temp[i++]=Escape;
	temp[i++]=((char)((y/240)*128+(x/8)));
	SendString(temp, i);
}

void writetext (char *text)
{
	while (*text)
	{	writecom(192);
		writebyte(*text++);
	}
}

void initlcd(void)
{
	setpwm(75);	//Kontrast einstellen

	setscroll(0);	


	writecom (11);		//Clear LCD

	clearbuffer();

	clearbuffer();

}

void uninitlcd(void)
{
	setpwm(10);	//Kontrast einstellen

	setscroll(0);	

	writecom (11);		//Clear LCD
}




void transfer (int xmin, int ymin, int xmax, int ymax)
{   int y,x,i,j=0;
	unsigned char c;
	unsigned char temp[250];

	for (y=ymin; y<ymax; y++)
	{	setcursor (xmin, y);
		j=0;
		for (x=xmin; x<xmax; x+=8)
		{c=0;
			for (i=0; i<8;i++)
				c+=lcdbuffer[y][x+i]*(1<<(7-i));
			if (c==Escape)
				temp[j++]=Escape;
			temp[j++]=c;
		}
		SendString(temp, j);
	}
}


void clearbuffer (void)
{   unsigned int y,x;

	for (y=0; y<480; y++)
		for (x=0; x<640; x++)
		lcdbuffer[y][x]=0;
}


